<?php
/**
 * ElasticOfferIncludes
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\CatalogCacheClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Catalog Cache
 *
 * Ensi Catalog Cache
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\CatalogCacheClient\Dto;

use \ArrayAccess;
use \Ensi\CatalogCacheClient\ObjectSerializer;

/**
 * ElasticOfferIncludes Class Doc Comment
 *
 * @category Class
 * @package  Ensi\CatalogCacheClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class ElasticOfferIncludes implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'ElasticOfferIncludes';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'discount' => '\Ensi\CatalogCacheClient\Dto\ElasticDiscount',
        'brand' => '\Ensi\CatalogCacheClient\Dto\ElasticBrand',
        'categories' => '\Ensi\CatalogCacheClient\Dto\ElasticCategory[]',
        'images' => '\Ensi\CatalogCacheClient\Dto\ElasticImage[]',
        'attributes' => '\Ensi\CatalogCacheClient\Dto\ElasticAttribute[]',
        'gluing' => '\Ensi\CatalogCacheClient\Dto\Gluing[]',
        'nameplates' => '\Ensi\CatalogCacheClient\Dto\ElasticNameplate[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'discount' => null,
        'brand' => null,
        'categories' => null,
        'images' => null,
        'attributes' => null,
        'gluing' => null,
        'nameplates' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'discount' => false,
        'brand' => false,
        'categories' => false,
        'images' => false,
        'attributes' => false,
        'gluing' => false,
        'nameplates' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::openAPINullables()[$property])) {
            return self::openAPINullables()[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'discount' => 'discount',
        'brand' => 'brand',
        'categories' => 'categories',
        'images' => 'images',
        'attributes' => 'attributes',
        'gluing' => 'gluing',
        'nameplates' => 'nameplates'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'discount' => 'setDiscount',
        'brand' => 'setBrand',
        'categories' => 'setCategories',
        'images' => 'setImages',
        'attributes' => 'setAttributes',
        'gluing' => 'setGluing',
        'nameplates' => 'setNameplates'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'discount' => 'getDiscount',
        'brand' => 'getBrand',
        'categories' => 'getCategories',
        'images' => 'getImages',
        'attributes' => 'getAttributes',
        'gluing' => 'getGluing',
        'nameplates' => 'getNameplates'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('discount', $data, null);
        $this->setIfExists('brand', $data, null);
        $this->setIfExists('categories', $data, null);
        $this->setIfExists('images', $data, null);
        $this->setIfExists('attributes', $data, null);
        $this->setIfExists('gluing', $data, null);
        $this->setIfExists('nameplates', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets discount
     *
     * @return \Ensi\CatalogCacheClient\Dto\ElasticDiscount|null
     */
    public function getDiscount()
    {
        return $this->container['discount'];
    }

    /**
     * Sets discount
     *
     * @param \Ensi\CatalogCacheClient\Dto\ElasticDiscount|null $discount discount
     *
     * @return $this
     */
    public function setDiscount($discount)
    {


        /*if (is_null($discount)) {
            throw new \InvalidArgumentException('non-nullable discount cannot be null');
        }*/
        $this->container['discount'] = $discount;

        return $this;
    }

    /**
     * Gets brand
     *
     * @return \Ensi\CatalogCacheClient\Dto\ElasticBrand|null
     */
    public function getBrand()
    {
        return $this->container['brand'];
    }

    /**
     * Sets brand
     *
     * @param \Ensi\CatalogCacheClient\Dto\ElasticBrand|null $brand brand
     *
     * @return $this
     */
    public function setBrand($brand)
    {


        /*if (is_null($brand)) {
            throw new \InvalidArgumentException('non-nullable brand cannot be null');
        }*/
        $this->container['brand'] = $brand;

        return $this;
    }

    /**
     * Gets categories
     *
     * @return \Ensi\CatalogCacheClient\Dto\ElasticCategory[]|null
     */
    public function getCategories()
    {
        return $this->container['categories'];
    }

    /**
     * Sets categories
     *
     * @param \Ensi\CatalogCacheClient\Dto\ElasticCategory[]|null $categories categories
     *
     * @return $this
     */
    public function setCategories($categories)
    {


        /*if (is_null($categories)) {
            throw new \InvalidArgumentException('non-nullable categories cannot be null');
        }*/
        $this->container['categories'] = $categories;

        return $this;
    }

    /**
     * Gets images
     *
     * @return \Ensi\CatalogCacheClient\Dto\ElasticImage[]|null
     */
    public function getImages()
    {
        return $this->container['images'];
    }

    /**
     * Sets images
     *
     * @param \Ensi\CatalogCacheClient\Dto\ElasticImage[]|null $images images
     *
     * @return $this
     */
    public function setImages($images)
    {


        /*if (is_null($images)) {
            throw new \InvalidArgumentException('non-nullable images cannot be null');
        }*/
        $this->container['images'] = $images;

        return $this;
    }

    /**
     * Gets attributes
     *
     * @return \Ensi\CatalogCacheClient\Dto\ElasticAttribute[]|null
     */
    public function getAttributes()
    {
        return $this->container['attributes'];
    }

    /**
     * Sets attributes
     *
     * @param \Ensi\CatalogCacheClient\Dto\ElasticAttribute[]|null $attributes attributes
     *
     * @return $this
     */
    public function setAttributes($attributes)
    {


        /*if (is_null($attributes)) {
            throw new \InvalidArgumentException('non-nullable attributes cannot be null');
        }*/
        $this->container['attributes'] = $attributes;

        return $this;
    }

    /**
     * Gets gluing
     *
     * @return \Ensi\CatalogCacheClient\Dto\Gluing[]|null
     */
    public function getGluing()
    {
        return $this->container['gluing'];
    }

    /**
     * Sets gluing
     *
     * @param \Ensi\CatalogCacheClient\Dto\Gluing[]|null $gluing gluing
     *
     * @return $this
     */
    public function setGluing($gluing)
    {


        /*if (is_null($gluing)) {
            throw new \InvalidArgumentException('non-nullable gluing cannot be null');
        }*/
        $this->container['gluing'] = $gluing;

        return $this;
    }

    /**
     * Gets nameplates
     *
     * @return \Ensi\CatalogCacheClient\Dto\ElasticNameplate[]|null
     */
    public function getNameplates()
    {
        return $this->container['nameplates'];
    }

    /**
     * Sets nameplates
     *
     * @param \Ensi\CatalogCacheClient\Dto\ElasticNameplate[]|null $nameplates nameplates
     *
     * @return $this
     */
    public function setNameplates($nameplates)
    {


        /*if (is_null($nameplates)) {
            throw new \InvalidArgumentException('non-nullable nameplates cannot be null');
        }*/
        $this->container['nameplates'] = $nameplates;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset): mixed
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
    * Convert object to array
    *
    * @return array
    */
    public function toArray()
    {
        return json_decode(json_encode(ObjectSerializer::sanitizeForSerialization($this)), true);
    }
}


